import { launch } from 'effector';
import { defer } from './promise';
import { assign, own } from './tools';
export const patchInstance = (instance, { cancelled, cancel, running }) => {
    assign(instance, { cancelled, cancel });
    own(instance, [cancelled, cancel]);
    instance.pending.reset(cancelled.filter({ fn: () => !running.length }));
    instance.create = (paramsOrConfig, _, [strategyOrConfig]) => {
        const config = (paramsOrConfig && paramsOrConfig.strategy
            ? paramsOrConfig
            : strategyOrConfig && strategyOrConfig.strategy
                ? strategyOrConfig
                : { strategy: strategyOrConfig });
        const req = defer();
        launch(instance, {
            params: config === paramsOrConfig ? config.params : paramsOrConfig,
            args: { strategy: config.strategy },
            req,
        });
        return req.req;
    };
};
